#include<stdio.h>
#include<math.h>
#include<complex.h> // 複素数関係のヘッダファイルを読み込む

int main(){

  double a_deg, b_deg, a_rad, b_rad, pi;
  double a_mat[2][2], b_mat[2][2], c_mat[2][2];
  int i,j,k;
  
  double _Complex a_complex, b_complex, c_complex;   // 倍精度複素数型の変数を定義

  printf("Enter a and b (deg)\n");  // aとbの入力を促す
  scanf("%lf %lf", &a_deg, &b_deg); // aとbを標準入力から読み込む

  /* 度からラジアンに変換。 M_PIは円周率 */
  a_rad = a_deg * M_PI / 180.0e0;
  b_rad = b_deg * M_PI / 180.0e0;

  /* cos(a+b)とsin(a+b)を出力 */
  printf("cos(a+b) = %f sin(a+b) = %f\n", cos(a_rad+b_rad), sin(a_rad+b_rad));


  /* 角度a回転の回転行列a_matを作る */
  a_mat[0][0] =  cos(a_rad);
  a_mat[0][1] = -sin(a_rad);
  a_mat[1][0] =  sin(a_rad);
  a_mat[1][1] =  cos(a_rad);

  /* 角度b回転の回転行列b_matを作る */
  b_mat[0][0] =  cos(b_rad);
  b_mat[0][1] = -sin(b_rad);
  b_mat[1][0] =  sin(b_rad);
  b_mat[1][1] =  cos(b_rad);

  /* a_matとb_matの行列の積をc_matに代入 */
  for(i=0;i<2;i++){
    for(j=0;j<2;j++){
      for(k=0;k<2;k++){
	c_mat[i][j] = c_mat[i][j] + a_mat[i][k] * b_mat[k][j];
      }
    }
  }

  /* c_matでcosとsinに対応する要素を出力 */
  printf("c[0][0]  = %f  c[1][0] = %f\n ", c_mat[0][0], c_mat[1][0]);

  /* 倍精度複素数変数a_complexの実部と虚部にcos(a_rad)とsin(a_rad)を代入
     I は虚数単位 */
  a_complex = cos(a_rad) + I * sin(a_rad);
  b_complex = cos(b_rad) + I * sin(b_rad);

  /* a_complexとb_complexの積をc_complexに代入 */
  c_complex = a_complex * b_complex;

  /* c_complexの実部と虚部を出力 */
  printf("Re(c)   = %f   Im(c)  = %f\n", creal(c_complex), cimag(c_complex));  
  
  return 0;
}
